#include <pthread.h>
#include <semaphore.h>
#include <stdio.h>
#include <stdlib.h>

#define MAX 10000000

// En renforce l'implémentation de Peterson avec une instruction de «barrière».
// __synch_synchronize insère une instruction assembleur qui interdit l'échange
// des read et write à cet endroit. L'implémentation est donc enfin correct.

char requete[2],victime;
int counter = 0;

void* count(void* data)
{
	int moi = (long int)data;
	int autre = 1-moi;

	int k;

	for (k = 0; k < MAX; k++)
	{
		requete[moi] = 1;	// algorithme de Peterson
		victime = moi;
		__sync_synchronize();
		while (requete[autre] && victime == moi);

		counter++;

		requete[moi] = 0;	// on quitte la section critique
	}
	return NULL;
}

int main(int argc, char * argv[])
{
	requete[0] = requete[1] = victime = 0;

	pthread_t t1;
	pthread_t t2;

	pthread_create(&t1, NULL, count, (void*)0);  // create first thread
	pthread_create(&t2, NULL, count, (void*)1);  // create second thread

	pthread_join(t1, NULL);  // wait for first thread
	pthread_join(t2, NULL);  // wait for second thread

	printf("Counter: %d\n", counter);
	return 0;
}
